package jf05;

/**
 *
 * @author Lefteris Moussiades
 */
public class Parameters {

    /**
     * Η συνάρτηση αυτή λαμβάνει μια ακέραιη παράμετρο και επιστρέφει true
     * εφόσον η παράμετρος είναι πρώτος αριθμός και false διαφορετικά
     *
     * @param num
     * @return
     */
    public static boolean isPrime(int num) {
        boolean rVal = true;
        for (int i = 2; i <= num / 2; i++) {
            if (num % i == 0) {
                rVal = false;
            }
        }
        return rVal;
    }

    /**
     * Τυπώνει τους αριθμούς απο το 1 έως το 100 που είναι πρώτοι
     */
    public static void chkPrimes() {
        for (int num = 1; num <= 100; num++) {
            if (isPrime(num)) {
                System.out.println("integer " + num + " is prime");
            }
        }
    }

    /**
     * Τυπώνει τους αριθμούς απο το 1 έως το 100 που δεν είναι πρώτοι
     */
    public static void chkNonPrimes() {
        for (int i = 1; i <= 100; i++) {
            if (!isPrime(i)) {
                System.out.println("integer " + i + " is not prime");
            }
        }
    }

   /**
    * Τυπώνει έναν πίνακα χαρακτήρων
    * @param array Ο πίνακας που θέλουμε να τυπωθεί
    */
    public static void print(char[] array) {
        System.out.print("{");
        for (char c : array) {
            System.out.print(c + " ");
        }
        System.out.print("}");
    }

    /**
     * Τυπώνει έναν πίνακα χαρακτήρων και προετοιμάζει ώστε το επόμενο output να ξεκινήσει στην επόμενη γραμμή
     * @param array 
     */
    public static void println(char[] array) {
        print(array);
        System.out.println();
    }

    /**
     * Παράγει έναν αντεστραμμένο πίνακα χαρακτήρων
     * @param input Ο πίνακας του οποίου αντεστραμμένο αντίγραφο θέλουμε 
     * @return Το αντεστραμμένο αντίγραφο του πίνακα εισόδου
     */
    public static char[] reverse(char[] input) {
        char[] rVal = new char[input.length];
        for (int i = 0; i < input.length; i++) {
            rVal[rVal.length - 1 - i] = input[i];
        }
        return rVal;
    }

   
    /**
     * Παράγει έναν πίνακα με την Αγγλική αλβάβητο
     * @param capitals Αν true ο παραγώμενος πίνακας περιέχει πεζά, διαφορετικά κεφαλαία
     * @return Τον πίνακα με την Αγγλική αλβάβητο σε πεζά ή κεφαλαία
     */
    public static char[] englishABt(boolean capitals) {
        char[] rVal = new char['z' - 'a' + 1];

        int i = 0;
        if (capitals) {
            for (char c = 'A'; c <= 'Z'; c++) {
                rVal[i++] = c;
            }
        } else {
            for (char c = 'a'; c <= 'z'; c++) {
                rVal[i++] = c;
            }
        }
        return rVal;
    }

    /**
    Παράγει έναν πίνακα με την Αγγλική αλβάβητο - Εναλακτική κωδικοποίηση
     * @param capitals Αν true ο παραγώμενος πίνακας περιέχει πεζά, διαφορετικά κεφαλαία
     * @return Τον πίνακα με την Αγγλική αλβάβητο σε πεζά ή κεφαλαία
     */
    public static char[] englishAB(boolean capitals) {
        char[] rVal = new char['z' - 'a' + 1];
        int offset = capitals ? 0: 'a' - 'A';
        int i = 0;
        for (char c = 'A'; c <= 'Z'; c++) {
            rVal[i++] = (char) (c + offset);
        }
        return rVal;
    }

    public static void main(String[] args) {
        //chkPrimes();
        //chkNonPrimes();
        
        println(englishABt(true)); // τυπώνει την Αγγλική Αλφάβητο με κεφαλαία
        
        println(englishABt(false));
        
        //println(englishAB(true)); // τυπώνει την Αγγλική Αλφάβητο με κεφαλαία
        
        //println(englishAB(false));
        println(reverse(englishAB(false))); //// τυπώνει την Αγγλική Αλφάβητο αντεστραμμένη με κεφαλαία

        
    }

}
